/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   main.c                                             :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: ale-batt <ale-batt@student.42.fr>          +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2016/01/23 12:31:55 by ale-batt          #+#    #+#             */
/*   Updated: 2016/01/25 20:07:27 by ale-batt         ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */

#include "ft_select.h"

t_env	*g_env(t_env *env)
{
	static t_env *save;

	if (env != NULL)
		save = env;
	return (save);
}

int		init_env(t_env *e)
{
	ft_bzero(e, sizeof(t_env));
	e->fd_tty = open("/dev/tty", O_RDWR);
	e->list_ret = NULL;
	g_env(e);
	if (e->fd_tty < 0)
		return (-1);
	return (1);
}

void	exit_clean(t_env *e)
{
	t_llist *tmp;

	close(e->fd_tty);
	while (e->list)
	{
		tmp = e->list;
		free(CONTENT->word);
		free(CONTENT);
		tmp = e->list;
		e->list = e->list->next;
		free(tmp);
	}
	free(e->list);
}

int		ft_select(void)
{
	char buff[4];

	while (42)
	{
		ft_clear_screen();
		print_list();
		ft_bzero(buff, 4);
		read(0, buff, 3);
		buff[3] = '\0';
		if (handle_key(buff) == 0)
			break ;
		usleep(500);
	}
	return (1);
}

int		main(int ac, char **av)
{
	t_env	*e;

	if (ac <= 1)
	{
		ft_putendl("Usage : ./ft_select argv1 argv2 argv3 ...");
		return (-1);
	}
	ft_signal_on();
	e = (t_env *)malloc(sizeof(t_env));
	ft_bzero(e, sizeof(t_env));
	if (init_env(e) == -1 || ft_terminal_on() == -1)
		return (-1);
	e->list = parser_argv(1 + av);
	ft_select();
	ft_terminal_off(&g_term_save);
	ft_signal_off();
	signal(SIGCONT, SIG_DFL);
	if (e->list_ret)
	{
		ft_putendl(e->list_ret);
		free(e->list_ret);
	}
	exit_clean(e);
	free(e);
}
