/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   print.c                                            :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: ale-batt <ale-batt@student.42.fr>          +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2016/01/24 15:59:27 by ale-batt          #+#    #+#             */
/*   Updated: 2016/01/25 20:11:07 by ale-batt         ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */

#include "ft_select.h"

static t_printav	*ft_init_av(void)
{
	t_printav	*av;
	int			*winsize;

	av = (t_printav *)malloc(sizeof(t_printav));
	winsize = ft_winsize();
	av->y = 0;
	av->bigger_word = 0;
	av->mov_size = -2;
	av->y_win = winsize[0];
	av->x_win = winsize[1];
	free(winsize);
	return (av);
}

static void			print_word(t_llist *tmp, char *word, int fd, t_printav *av)
{
	size_t size;

	size = (av->x_win - av->mov_size) - 2;
	if (ft_is_dir(word) != 0)
		ft_putstr_fd("\033[34m", fd);
	else
		ft_putstr_fd("\033[32m", fd);
	if (CONTENT->select == 1)
		ft_reverse_video(tmp, fd, size);
	else if (CONTENT->cursor == 1)
		underline_line(tmp, fd, size);
	else
	{
		if (size > ft_strlen(word))
			size = ft_strlen(word);
		write(fd, word, size);
	}
	ft_putstr_fd("\033[0m", fd);
}

void				print_list(void)
{
	t_env		*e;
	t_llist		*list;
	t_llist		*tmp;
	t_printav	*av;

	e = g_env(NULL);
	list = e->list;
	tmp = list;
	av = ft_init_av();
	while (tmp)
	{
		if (av->mov_size >= av->x_win)
			break ;
		move_cursor_to(av->mov_size + 2, av->y++);
		print_word(tmp, CONTENT->word, e->fd_tty, av);
		if (CONTENT->len > av->bigger_word)
			av->bigger_word = CONTENT->len;
		if (av->y == av->y_win)
		{
			av->mov_size += av->bigger_word + 2;
			av->bigger_word = 0;
			av->y = 0;
		}
		tmp = tmp->next;
	}
	free(av);
}
